Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/misc/Attribute.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/misc/Attribute.java	(revision 1573)
+++ 	(revision )
@@ -1,82 +1,0 @@
-// Attribute.java
-//
-// (c) 1999-2001 PAL Development Core Team
-//
-// This package may be distributed under the
-// terms of the Lesser GNU General Public License (LGPL)
-
-package de.ugoe.cs.autoquest.tasktrees.alignment.pal.misc;
-
-
-
-/**
- * An immutable attribute has a name and value.
- * A convenience constructor for conversion from 
- * string to types Boolean, Integer, Double, Float is available.
- *
- * @version $Id: Attribute.java,v 1.1 2001/11/21 22:17:07 alexi Exp $
- *
- * @author Alexei Drummond
- */
-
-
-public class Attribute { 
-	
-	public static final String STRING = "string";
-	public static final String INTEGER = "integer";
-	public static final String BOOLEAN = "boolean";
-	public static final String DOUBLE = "double";
-	public static final String FLOAT = "float";
-	
-	/** the name of this attribute */
-	private String name = null;
-
-	/** the value of this attribute */
-	private Object value = null;
-	
-	/**
-	 * @param name the name of the attribute.
-	 * @param val the value as a string
-	 * @param type a string description of the type the value is. One of 'boolean', 
-	 * 'integer', 'double', 'float', 'string'
-	 */
-	public Attribute(String name, String val, String type) {
-		
-		this.name = name;
-		
-		if (type == null) {
-			try {
-				value = new Integer(val);
-			} catch (NumberFormatException nfe1) {
-				try {
-					value = new Double(val);
-				} catch (NumberFormatException nfe2) {
-					value = val;
-				}
-			} 
-		} else if (type.equals(BOOLEAN)) {
-			value = new Boolean(val);
-		} else if (type.equals(INTEGER)) {
-			value = new Integer(val);
-		} else if (type.equals(DOUBLE)) {
-			value = new Double(val);
-		} else if (type.equals(FLOAT)) {
-			value = new Float(val);
-		} 
-		value = val;
-	}
-	
-	public Attribute(String name, Object value) {
-		this.name = name;
-		this.value = value;
-	}
-
-	public String getName() {
-		return name;
-	}
-
-	public Object getValue() {
-		return value;
-	}
-}
-
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/misc/BranchLimits.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/misc/BranchLimits.java	(revision 1573)
+++ 	(revision )
@@ -1,39 +1,0 @@
-// BranchLimits.java
-//
-// (c) 1999-2001 PAL Development Core Team
-//
-// This package may be distributed under the
-// terms of the Lesser GNU General Public License (LGPL)
-
-
-package de.ugoe.cs.autoquest.tasktrees.alignment.pal.misc;
-
-
-/**
- * limits for branch lengths
- *
- * @version $Id: BranchLimits.java,v 1.9 2001/09/09 22:15:16 alexi Exp $
- *
- * @author Korbinian Strimmer
- */
-public interface BranchLimits
-{
-	//
-	// Public stuff
-	//
-
-	/** minimum branch length */
-	double MINARC = 1.0e-9;
-	
-	/** maximum branch length */
-	double MAXARC = 100.0;
-	
-	/** default branch length */
-	double DEFAULT_LENGTH = 0.04;
-	
-	/** maximum tolerated error when determining branch lengths */
-	double ABSTOL = 5.0e-07;
-	
-	/** desired fractional digits when determining branch lengths */
-	int FRACDIGITS = 6;
-}
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/misc/Identifier.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/misc/Identifier.java	(revision 1573)
+++ branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/misc/Identifier.java	(revision 1579)
@@ -8,5 +8,4 @@
 package de.ugoe.cs.autoquest.tasktrees.alignment.pal.misc;
 
-import java.io.Serializable;
 import de.ugoe.cs.autoquest.tasktrees.alignment.pal.util.Comparable;
 
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/misc/LabelMapping.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/misc/LabelMapping.java	(revision 1573)
+++ 	(revision )
@@ -1,61 +1,0 @@
-// LableMapping.java
-//
-// (c) 1999-2001 PAL Development Core Team
-//
-// This package may be distributed under the
-// terms of the Lesser GNU General Public License (LGPL)
-
-package de.ugoe.cs.autoquest.tasktrees.alignment.pal.misc;
-
-/**
- * Title:        LabelMapping
- * Description:  Allows for the substitution of one label for another
- * @author			 Matthew Goode
- * @version 1.0
- */
-import java.util.*;
-public class LabelMapping implements java.io.Serializable {
-	Hashtable mappings_ = new Hashtable();
-	public LabelMapping() { }
-
-	public void addMapping(String id, String label) {
-		mappings_.put(id,label);
-	}
-	public void addMapping(Identifier id, String label) {
-		if(id!=null&&id.getName()!=null) {
-			mappings_.put(id.getName(),label);
-		}
-	}
-	/**
-	 * @param names Names
-	 * @param colours associated colours
-	 * @note assumes parallel arrays
-	 */
-	public void addMappings(String[] ids, String[] labels) {
-		for(int i = 0 ; i < ids.length ; i++) {
-			mappings_.put(ids[i],labels[i]);
-		}
-	}
-
-	public String getLabel(String id, String defaultLabel) {
-		if(id==null||!mappings_.containsKey(id)) {
-			return defaultLabel;
-		}
-		return mappings_.get(id).toString();
-	}
-	public String getLabel(Identifier id, String defaultLabel) {
-		if(id==null) {
-			return defaultLabel;
-		}
-		return getLabel(id.getName(),defaultLabel);
-	}
-	public String getLabel(Identifier id) {
-		return getLabel(id.getName(),id.getName());
-	}
-	public Identifier getLabelIdentifier(Identifier id) {
-		if(id==null) {
-			return null;
-		}
-		return new Identifier(getLabel(id.getName(),id.getName()));
-	}
-}
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/misc/Utils.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/misc/Utils.java	(revision 1573)
+++ 	(revision )
@@ -1,113 +1,0 @@
-// Utils.java
-//
-// (c) 1999-2001 PAL Development Core Team
-//
-// This package may be distributed under the
-// terms of the Lesser GNU General Public License (LGPL)
-
-package de.ugoe.cs.autoquest.tasktrees.alignment.pal.misc;
-
-
-
-/**
- * Provides some miscellaneous methods.
- *
- * @version $Id: Utils.java,v 1.9 2001/11/20 19:58:45 alexi Exp $
- *
- * @author Matthew Goode
- */
-public class Utils {
-
-	/** Clones an array of doubles
-		* @return null if input is null, otherwise return complete copy.
-		*/
-	public static final double[] getCopy(double[] array) {
-
-		if(array == null) {
-			return null;
-		}
-		double[] copy = new double[array.length];
-		System.arraycopy(array,0,copy,0,array.length);
-		return copy;
-	}
-	
-	/** 
-	 * Clones an array of doubles
-	 * @return null if input is null, otherwise return complete copy.
-	 */
-	public static final double[][] getCopy(double[][] array) {
-
-		if(array == null) {
-			return null;
-		}
-		double[][] copy = new double[array.length][];
-		for(int i = 0 ; i < copy.length ; i++) {
-			copy[i] = new double[array[i].length];
-			System.arraycopy(array[i],0,copy[i],0,array[i].length);
-		}
-		return copy;
-	}
-
-	/** 
-	 * Clones an array of ints
-	 * @return null if input is null, otherwise return complete copy.
-	 */
-	public static final int[] getCopy(int[] array) {
-		if(array == null) {
-			return null;
-		}
-		int[] copy = new int[array.length];
-		System.arraycopy(array,0,copy,0,array.length);
-		return copy;
-	}
-
-	/** Copies all of source into dest - assumes dest to be large enough */
-	public static final void copy(double[][] source, double[][] dest) {
-		for(int i = 0 ; i < source.length ; i++) {
-			System.arraycopy(source[i],0,dest[i],0,source[i].length);
-		}
-	}
-
-	/** 
-	 * A simple toString method for an array of doubles.
-	 * No fancy formating.
-	 * Puts spaces between each value
-	 */
-	public static final String toString(double[] array) {
-		StringBuffer sb = new StringBuffer(array.length*7);
-		for(int i = 0 ; i < array.length ; i++) {
-			sb.append(array[i]);
-			sb.append(' ');
-		}
-		return sb.toString();
-	}
-	/** 
-	 * A simple toString method for an array of ints.
-	 * No fancy formating.
-	 * Puts spaces between each value
-	 */
-	public static final String toString(int[] array) {
-		StringBuffer sb = new StringBuffer(array.length*7);
-		for(int i = 0 ; i < array.length ; i++) {
-			sb.append(array[i]);
-			sb.append(' ');
-		}
-		return sb.toString();
-	}
-		
-	/** 
-	 * A simple toString method for an array of doubles.
-	 * No fancy formating.
-	 * Puts spaces between each value
-	 */
-	public static final String toString(double[][] array) {
-		String ss = "";
-		for(int i = 0 ; i < array.length ; i++) {
-			ss+= i+":"+toString(array[i])+'\n';
-		}
-		return ss;
-	}
-}
-
-
-