Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/FengDoolittleNode.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/FengDoolittleNode.java	(revision 1579)
+++ branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/FengDoolittleNode.java	(revision 1580)
@@ -374,5 +374,5 @@
 		newNode.addChild(child2);
 		newNode.setIdentifier(new Identifier(child1.getIdentifier().getName() + " " + child2.getIdentifier().getName()));
-		System.out.println("Merging " + child1.getIdentifier() + " with " + child2.getIdentifier());
+		//System.out.println("Merging " + child1.getIdentifier() + " with " + child2.getIdentifier());
 		
 		if(newNode instanceof FengDoolittleNode) {
@@ -410,5 +410,5 @@
 		}
 		else {
-			
+			System.out.println("This should never happen, it's a binary tree.");
 		}
 		
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/Node.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/Node.java	(revision 1579)
+++ branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/Node.java	(revision 1580)
@@ -134,5 +134,4 @@
 	ArrayList<NumberSequence> getSequences();
 	
-	
 	void joinChildren( int n1, int n2);
 
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/NodeUtils.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/NodeUtils.java	(revision 1579)
+++ branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/NodeUtils.java	(revision 1580)
@@ -9,7 +9,5 @@
 package de.ugoe.cs.autoquest.tasktrees.alignment.pal.tree;
 
-import java.io.*;
-
-import de.ugoe.cs.autoquest.tasktrees.alignment.pal.io.FormattedOutput;
+
 import de.ugoe.cs.autoquest.tasktrees.alignment.pal.misc.Identifier;
 
@@ -377,74 +375,7 @@
 	}
 
-	/**
-	 * prints node in New Hamshire format.
-	 */
-	static void printNH(PrintWriter out, Node node,
-		boolean printLengths, boolean printInternalLabels) {
-
-		printNH(out, node, printLengths, printInternalLabels, 0, true);
-	}
-
-
-	static int printNH(PrintWriter out, Node node,
-		boolean printLengths, boolean printInternalLabels, int column, boolean breakLines) {
-
-		if (breakLines) column = breakLine(out, column);
-
-		if (!node.isLeaf())
-		{
-			out.print("(");
-			column++;
-
-			for (int i = 0; i < node.getChildCount(); i++)
-			{
-				if (i != 0)
-				{
-					out.print(",");
-					column++;
-				}
-
-				column = printNH(out, node.getChild(i), printLengths, printInternalLabels, column, breakLines);
-			}
-
-			out.print(")");
-			column++;
-		}
-
-		if (!node.isRoot())
-		{
-			if (node.isLeaf() || printInternalLabels)
-			{
-				if (breakLines) column = breakLine(out, column);
-
-				String id = node.getIdentifier().toString();
-				out.print(id);
-				column += id.length();
-			}
-
-			if (printLengths)
-			{
-				out.print(":");
-				column++;
-
-				if (breakLines) column = breakLine(out, column);
-
-				column += FormattedOutput.getInstance().displayDecimal(out, node.getBranchLength(), 7);
-			}
-		}
-
-		return column;
-	}
-
-	private static int breakLine(PrintWriter out, int column)
-	{
-		if (column > 70)
-		{
-			out.println();
-			column = 0;
-		}
-
-		return column;
-	}
+
+
+
 	/**
 	 * Returns the first nodes in this tree that has the
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/SimpleTree.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/SimpleTree.java	(revision 1579)
+++ branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/tree/SimpleTree.java	(revision 1580)
@@ -8,8 +8,4 @@
 
 package de.ugoe.cs.autoquest.tasktrees.alignment.pal.tree;
-
-import java.io.PrintWriter;
-import java.io.StringWriter;
-
 
 import de.ugoe.cs.autoquest.tasktrees.alignment.pal.misc.Identifier;
@@ -198,14 +194,4 @@
 
 
-	public String toString() {
-		StringWriter sw = new StringWriter();
-		NodeUtils.printNH(new PrintWriter(sw), getRoot(), false, true, 0, true);
-		sw.write(";");
-		return sw.toString();
-	}
-
-
-
-
 
 
Index: branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/util/ComparableDouble.java
===================================================================
--- branches/ralph/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/pal/util/ComparableDouble.java	(revision 1579)
+++ 	(revision )
@@ -1,49 +1,0 @@
-// ComparableDouble.java
-//
-// (c) 1999-2001 PAL Development Core Team
-//
-// This package may be distributed under the
-// terms of the Lesser GNU General Public License (LGPL)
-
-package de.ugoe.cs.autoquest.tasktrees.alignment.pal.util;
-
-/** 
- * This class is unfortunate but necessary to conform to JDK 1.1
- *
- * @version $Id: ComparableDouble.java,v 1.3 2001/07/13 14:39:13 korbinian Exp $
- *
- * @author Alexei Drummond
- */
-public class ComparableDouble implements Comparable {
-	
-	private double value;
-
-	public ComparableDouble(double d) {
-		value = d;
-	}
-
-	public int compareTo(Object o) {
-		
-		ComparableDouble cd = (ComparableDouble)o;
-
-		if (value < cd.value) {
-			return -1;
-		} else if (value > cd.value) {
-			return 1;
-		} else return 0;
-	}
-
-	public boolean equals(Object o) {
-	
-		ComparableDouble cd = (ComparableDouble)o;
-		return cd.value == value;
-	}
-
-	public double doubleValue() {
-		return value;
-	}
-
-	public String toString() {
-		return value + "";
-	}
-}