Index: trunk/autoquest-plugin-http-test/src/test/java/de/ugoe/cs/autoquest/http/HTTPLogParserTest.java
===================================================================
--- trunk/autoquest-plugin-http-test/src/test/java/de/ugoe/cs/autoquest/http/HTTPLogParserTest.java	(revision 1591)
+++ trunk/autoquest-plugin-http-test/src/test/java/de/ugoe/cs/autoquest/http/HTTPLogParserTest.java	(revision 1623)
@@ -46,9 +46,10 @@
 /**
  * Test for the new HTMLLogParser
+ * 
  * @author Fabian Glaser
- *
+ * 
  */
 public class HTTPLogParserTest {
-    
+
     /**
      * 
@@ -71,7 +72,8 @@
         deleteFiles(new File(LOG_FILE_DIR));
     }
-    
+
     /**
      * Tests the parseFile method with a given trace file.
+     * 
      * @throws Exception
      */
@@ -81,5 +83,5 @@
             File logFile = new File(LOG_FILE_DIR, "session" + i + ".xml");
 
-            Session session = HTTPTestUtils.createRandomSession(100); 
+            Session session = HTTPTestUtils.createRandomSession(100);
             writeToFile(session, logFile);
 
@@ -116,7 +118,7 @@
                     assertTrue(sequence.get(j).getTarget() instanceof HTTPTarget);
 
-                    HTTPTestUtils.assertExchangeEquals
-                        (session.getHttpExchange().get(j),
-                         ((HTTPEventType) sequence.get(j).getType()).getExchange());
+                    HTTPTestUtils.assertExchangeEquals(session.getHttpExchange().get(j),
+                                                       ((HTTPEventType) sequence.get(j).getType())
+                                                           .getExchange());
 
                     assertEquals(HTTPUtils.toString(session.getHttpExchange().get(j).getReceiver()),
@@ -129,7 +131,8 @@
         }
     }
-    
+
     /**
      * Tests the parseFile method with a given trace file.
+     * 
      * @throws Exception
      */
@@ -137,11 +140,11 @@
     public void testParseFile_2() throws Exception {
         HTTPLogParser parser = new HTTPLogParser();
-        parser.parseFile
-            (new File(ClassLoader.getSystemResource("httpmonitor_testtrace_1.xml").getFile()));
+        parser.parseFile(new File(ClassLoader.getSystemResource("httpmonitor_testtrace_1.xml")
+            .getFile()));
         Collection<List<Event>> events = parser.getSequences();
 
         assertNotNull(events);
         assertEquals(1, events.size());
-        
+
         Iterator<List<Event>> iterator = events.iterator();
         assertNotNull(iterator);
@@ -157,5 +160,5 @@
                 System.out.print(event);
                 System.out.println(",");
-                
+
                 if (event.getType() instanceof SOAPEventType) {
                     assertNotNull(((SOAPEventType) event.getType()).getCalledMethod());
@@ -167,8 +170,53 @@
         System.out.println("}");
         System.out.println("\n\n");
-        
+
         assertEquals(870, soapEvents.size());
     }
-    
+
+    /**
+     * Tests the parseFile method with a given trace file.
+     * 
+     * @throws Exception
+     */
+    @Test
+    public void testParseFile_3() throws Exception {
+        // tests parsing with properties
+        HTTPLogParser parser =
+            new HTTPLogParser(new File(ClassLoader
+                .getSystemResource("testParseFile_3_properties.txt").getFile()));
+        parser.parseFile(new File(ClassLoader.getSystemResource("testParseFile_3_logfile.log")
+            .getFile()));
+        Collection<List<Event>> events = parser.getSequences();
+
+        assertNotNull(events);
+        assertEquals(1, events.size());
+
+        Iterator<List<Event>> iterator = events.iterator();
+        assertNotNull(iterator);
+        assertEquals(153, iterator.next().size());
+        assertFalse(iterator.hasNext());
+
+        List<Event> soapEvents = new LinkedList<Event>();
+        System.out.println("{");
+        for (List<Event> session : events) {
+            System.out.println("  {");
+            for (Event event : session) {
+                System.out.print("    ");
+                System.out.print(event);
+                System.out.println(",");
+
+                if (event.getType() instanceof SOAPEventType) {
+                    assertNotNull(((SOAPEventType) event.getType()).getCalledMethod());
+                    soapEvents.add(event);
+                }
+            }
+            System.out.println("  }");
+        }
+        System.out.println("}");
+        System.out.println("\n\n");
+
+        assertEquals(147, soapEvents.size());
+    }
+
     /**
      * @throws Exception
@@ -177,11 +225,11 @@
     public void testSerializability_1() throws Exception {
         HTTPLogParser parser = new HTTPLogParser();
-        parser.parseFile
-            (new File(ClassLoader.getSystemResource("httpmonitor_testtrace_1.xml").getFile()));
+        parser.parseFile(new File(ClassLoader.getSystemResource("httpmonitor_testtrace_1.xml")
+            .getFile()));
         Collection<List<Event>> events = parser.getSequences();
 
         assertNotNull(events);
         assertEquals(1, events.size());
-        
+
         Iterator<List<Event>> iterator = events.iterator();
         assertNotNull(iterator);
@@ -196,5 +244,5 @@
         }
     }
-    
+
     /**
      *
@@ -202,12 +250,12 @@
     private void writeToFile(Session session, File logFile) throws Exception {
         System.out.println("writing session to " + logFile);
-        
+
         logFile.getParentFile().mkdirs();
-        
+
         JAXBContext jaxbContext = JAXBContext.newInstance(Session.class.getPackage().getName());
         Marshaller marshaller = jaxbContext.createMarshaller();
         StreamResult result = new StreamResult(new FileOutputStream(logFile));
         marshaller.marshal(new ObjectFactory().createSession(session), result);
-        
+
         result.getOutputStream().close();
     }
@@ -223,5 +271,5 @@
                 }
             }
-            
+
             try {
                 file.delete();