Index: trunk/autoquest-plugin-http/src/main/java/de/ugoe/cs/autoquest/plugin/http/eventcore/SOAPEventType.java
===================================================================
--- trunk/autoquest-plugin-http/src/main/java/de/ugoe/cs/autoquest/plugin/http/eventcore/SOAPEventType.java	(revision 1622)
+++ trunk/autoquest-plugin-http/src/main/java/de/ugoe/cs/autoquest/plugin/http/eventcore/SOAPEventType.java	(revision 1635)
@@ -47,5 +47,5 @@
      * </p>
      */
-    transient private SOAPMessage soapRequest;
+    transient private final SOAPMessage soapRequest;
     
     /**
@@ -54,5 +54,5 @@
      * </p>
      */
-    transient private SOAPMessage soapResponse;
+    transient private final SOAPMessage soapResponse;
     
     /**
@@ -61,11 +61,12 @@
      * </p>
      */
-    private String calledMethod;
+    private final String calledMethod;
     
     /**
      * <p>
      * the name of the service; this is either the path or, if a path map is available
-     */
-    private String serviceName;
+     * </p>
+     */
+    private final String serviceName;
     
     /**
@@ -74,5 +75,5 @@
      * </p>
      */
-    private String name;
+    private final String name;
 
     /**
@@ -227,5 +228,6 @@
             return
                 super.equals(obj) &&
-                HTTPUtils.equals(calledMethod, ((SOAPEventType) obj).calledMethod);
+                HTTPUtils.equals(calledMethod, ((SOAPEventType) obj).calledMethod) &&
+                HTTPUtils.equals(serviceName, ((SOAPEventType) obj).serviceName);
         }
         else {
@@ -239,10 +241,12 @@
     @Override
     public int hashCode() {
+        int hashCode = super.hashCode();
         if (calledMethod != null) {
-            return super.hashCode() + calledMethod.hashCode();
-        }
-        else {
-            return super.hashCode();
-        }
+            hashCode += calledMethod.hashCode();
+        }
+        if( serviceName != null ) {
+            hashCode += serviceName.hashCode();
+        }
+        return hashCode;
     }
 
Index: trunk/autoquest-plugin-http/src/main/java/de/ugoe/cs/autoquest/plugin/http/eventcore/SimpleSOAPEventType.java
===================================================================
--- trunk/autoquest-plugin-http/src/main/java/de/ugoe/cs/autoquest/plugin/http/eventcore/SimpleSOAPEventType.java	(revision 1635)
+++ trunk/autoquest-plugin-http/src/main/java/de/ugoe/cs/autoquest/plugin/http/eventcore/SimpleSOAPEventType.java	(revision 1635)
@@ -0,0 +1,131 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.plugin.http.eventcore;
+
+import de.ugoe.cs.autoquest.eventcore.IEventType;
+import de.ugoe.cs.autoquest.plugin.http.HTTPUtils;
+
+/**
+ * <p>
+ * A simplified SOAP event type that only contains the name of the called method and the name of the
+ * service.
+ * </p>
+ * 
+ * @author Steffen Herbold
+ */
+public class SimpleSOAPEventType implements IEventType {
+
+    /**  */
+    private static final long serialVersionUID = 1L;
+
+    /**
+     * <p>
+     * the SOAP method called in this request
+     * </p>
+     */
+    private final String calledMethod;
+
+    /**
+     * <p>
+     * the name of the service; this is either the path or, if a path map is available
+     * </p>
+     */
+    private final String serviceName;
+
+    /**
+     * <p>
+     * Constructor. Creates a new SimpleSOAPEventType.
+     * </p>
+     * 
+     */
+    public SimpleSOAPEventType(String calledMethod, String serviceName) {
+        if (calledMethod == null) {
+            throw new IllegalArgumentException("called method must not be null");
+        }
+        if (serviceName == null) {
+            throw new IllegalArgumentException("serviceName must not be null");
+        }
+        this.calledMethod = calledMethod;
+        this.serviceName = serviceName;
+    }
+
+    /**
+     * <p>
+     * the SOAP method called in this request
+     * </p>
+     * 
+     * @return the SOAP method called in this request
+     */
+    public String getCalledMethod() {
+        return calledMethod;
+    }
+
+    /**
+     * <p>
+     * the name of the service called in this request
+     * </p>
+     * 
+     * @return the name of the service called in this request
+     */
+    public String getServiceName() {
+        return serviceName;
+    }
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.autoquest.eventcore.IEventType#getName()
+     */
+    @Override
+    public String getName() {
+        return "(" + serviceName + ", " + calledMethod + ")";
+    }
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.autoquest.plugin.http.eventcore.HTTPEventType#equals(java.lang.Object)
+     */
+    @Override
+    public boolean equals(Object obj) {
+        if (this == obj) {
+            return true;
+        }
+        else if (obj instanceof SimpleSOAPEventType) {
+            return HTTPUtils.equals(calledMethod, ((SimpleSOAPEventType) obj).getCalledMethod()) &&
+                HTTPUtils.equals(serviceName, ((SimpleSOAPEventType) obj).getServiceName());
+        }
+        else {
+            return false;
+        }
+    }
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.autoquest.plugin.http.eventcore.HTTPEventType#hashCode()
+     */
+    @Override
+    public int hashCode() {
+        int hashCode = super.hashCode();
+        if (calledMethod != null) {
+            hashCode += calledMethod.hashCode();
+        }
+        if (serviceName != null) {
+            hashCode += serviceName.hashCode();
+        }
+        return hashCode;
+    }
+}