Index: branches/autoquest-core-tasktrees-alignment-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/alignment/algorithms/NumberSequenceTest.java
===================================================================
--- branches/autoquest-core-tasktrees-alignment-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/alignment/algorithms/NumberSequenceTest.java	(revision 1648)
+++ branches/autoquest-core-tasktrees-alignment-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/alignment/algorithms/NumberSequenceTest.java	(revision 1649)
@@ -21,5 +21,12 @@
 		
 		int[] pat5 = new int[]{-1,-1,-1};
+		
 		int[] pat6 = new int[]{10,11,12};
+		
+		int[] pat7 = new int[]{8,9,10};
+		int[] pat8 = new int[]{7,6,5};
+		
+		int[] pat9 = new int[]{0};
+		int[] pat10 = new int[]{1};
 		
 		
@@ -34,7 +41,7 @@
 		Match pattern = new Match();
 		pattern.setFirstSequence(firstpattern);
-		pattern.setSecondSequence(secondpattern);
-		
+		pattern.setSecondSequence(secondpattern);		
 		assertEquals(Integer.valueOf(2),ns.containsPattern(pattern).get(0));
+		assertEquals(1,ns.containsPattern(pattern).size());
 		
 		firstpattern.setSequence(pat3);
@@ -43,14 +50,24 @@
 		assertEquals(Integer.valueOf(1),ns.containsPattern(pattern).get(0));
 		assertEquals(Integer.valueOf(5),ns.containsPattern(pattern).get(1));
+		assertEquals(2,ns.containsPattern(pattern).size());
 	
 		firstpattern.setSequence(pat5);
 		secondpattern.setSequence(pat5);
-		
 		assertEquals(0,ns.containsPattern(pattern).size());
 		
 		firstpattern.setSequence(pat6);
 		secondpattern.setSequence(pat6);
+		assertEquals(0,ns.containsPattern(pattern).size());
 		
+		firstpattern.setSequence(pat7);
+		secondpattern.setSequence(pat8);
 		assertEquals(0,ns.containsPattern(pattern).size());
+		
+		firstpattern.setSequence(pat9);
+		secondpattern.setSequence(pat10);
+		assertEquals(Integer.valueOf(0),ns.containsPattern(pattern).get(0));
+		assertEquals(Integer.valueOf(1),ns.containsPattern(pattern).get(1));
+		assertEquals(2,ns.containsPattern(pattern).size());
+	
 	}
 
Index: branches/autoquest-core-tasktrees-alignment-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/alignment/algorithms/SmithWatermanRepeatedTest.java
===================================================================
--- branches/autoquest-core-tasktrees-alignment-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/alignment/algorithms/SmithWatermanRepeatedTest.java	(revision 1648)
+++ branches/autoquest-core-tasktrees-alignment-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/alignment/algorithms/SmithWatermanRepeatedTest.java	(revision 1649)
@@ -5,30 +5,93 @@
 import org.junit.Test;
 
+import de.ugoe.cs.autoquest.tasktrees.alignment.matrix.DummySubstitutionMatrix;
+
 public class SmithWatermanRepeatedTest {
 
 	@Test
 	public void testGetMaxScore() {
-		fail("Not yet implemented");
+		int[] seq1 = new int[]{0,1,2,3,4,5,6,7,8,9};
+		int[] seq2 = new int[]{0,1,2,3,4,5,6,7,8,9};
+		
+		NumberSequence ns1 = new NumberSequence(10);
+		NumberSequence ns2 = new NumberSequence(10);
+		
+		ns1.setSequence(seq1);
+		ns2.setSequence(seq2);
+		
+		DummySubstitutionMatrix submat = new DummySubstitutionMatrix();
+		
+		AlignmentAlgorithm testalignment1 = AlignmentAlgorithmFactory
+				.create();
+		testalignment1.align(ns1, ns2,submat,5);
+
+		assertTrue(testalignment1.getMaxScore()==10);
 	}
 
 	@Test
 	public void testGetAlignmentScore() {
-		fail("Not yet implemented");
+		int[] seq1 = new int[]{0,1,2,3,4,5,6,7,8,9};
+		int[] seq2 = new int[]{0,1,2,3,4,5,6,7,8,9};
+		
+		NumberSequence ns1 = new NumberSequence(10);
+		NumberSequence ns2 = new NumberSequence(10);
+		
+		ns1.setSequence(seq1);
+		ns2.setSequence(seq2);
+		
+		DummySubstitutionMatrix submat = new DummySubstitutionMatrix();
+		
+		AlignmentAlgorithm testalignment1 = AlignmentAlgorithmFactory
+				.create();
+		testalignment1.align(ns1, ns2,submat,5);
+		assertTrue(testalignment1.getAlignmentScore()==5);
 	}
 
 	@Test
 	public void testGetMatches() {
-		fail("Not yet implemented");
+		int[] seq1 = new int[]{0,1,2,3,4,5,6,7,8,9};
+		int[] seq2 = new int[]{3,4,5,6,7};
+		
+		NumberSequence ns1 = new NumberSequence(10);
+		NumberSequence ns2 = new NumberSequence(10);
+		
+		ns1.setSequence(seq1);
+		ns2.setSequence(seq2);
+		
+		DummySubstitutionMatrix submat = new DummySubstitutionMatrix();
+		
+		AlignmentAlgorithm testalignment1 = AlignmentAlgorithmFactory
+				.create();
+		testalignment1.align(ns1, ns2,submat,4);
+		testalignment1.printDPMatrix();
+		testalignment1.printAlignment();
+		
+		//testalignment1.getMatches().get(0).getFirstSequence().printSequence();
+		//testalignment1.getMatches().get(0).getSecondSequence().printSequence();
+		
 	}
 
-	@Test
-	public void testGetAlignment() {
-		fail("Not yet implemented");
-	}
 
+	//TODO: Need a better substitution matrix to do proper testing
 	@Test
 	public void testAlign() {
-		fail("Not yet implemented");
-	}
+		int[] seq1 = new int[]{0,1,2, 3, 4, 5,6,7,8,9};
+		int[] seq2 = new int[]{0,1,2,10,11,12,6,7,8,9};
+		
+		
+		NumberSequence ns1 = new NumberSequence(10);
+		NumberSequence ns2 = new NumberSequence(10);
+		
+		ns1.setSequence(seq1);
+		ns2.setSequence(seq2);
+		
+		DummySubstitutionMatrix submat = new DummySubstitutionMatrix();
+		
+		AlignmentAlgorithm testalignment1 = AlignmentAlgorithmFactory
+				.create();
+		testalignment1.align(ns1, ns2,submat,3);
+		//assertTrue(testalignment1.getAlignmentScore()==7);
+		
+		}
 
 }